%First import parameters table from Excel
load('params.mat')

TFR_policy=zeros(15,10);
TFR_nopolicy=zeros(15,10);
h_policy=zeros(15,10);
h_nopolicy=zeros(15,10);
TFR_base=zeros(15,10);
h_base=zeros(15,10);

TFR_data_mat=zeros(15,3);
h_data_mat=zeros(15,3);

parameters = zeros(15,12);

for j=1:15
    %values from data (weighted by working age population)
    n=params(1,j);
    h=params(2,j);
    CtoY=params(8,j); %hh consumption per worker
    gY=params(7,j);
    N0=params(3,j);
    N1=params(4,j);
    taug=params(11,j);
    mincer=params(13,j)/100;

    %mincer=0.11;
    rho=0.33;
    tau1=0.003;
    hbar=1;
    gA=1.56;

    tauh=tau1+(taug/(n*h));
    parameters(j,2)=tauh;

    u0=[0.02, 2.7, 0.11];
    u = fsolve(@(u) calibration_specific(u, tauh, CtoY, n, h, gY, N0, N1, rho, gA),u0); 
    
    if u(1)>0
        tau0=u(1);
    else
        tau0=0;
    end
    gH=u(2);
    alpha=u(3);
    
    parameters(j,1)=tau0;
    parameters(j,3)=alpha;
    parameters(j,12)=gH;
    
    z_lower=(gH-1)/h;
    z_upper=gH/h;
    
    parameters(j,7)=z_lower;
    parameters(j,9)=z_upper;

    z_vec=linspace(z_lower+0.001, z_upper-0.001, 9);
    theta_vec=zeros(1, 9);
    H0_vec=zeros(1, 9);

    for i=1:9
        z=z_vec(1,i);
        x0=[0.02, 2.7];
        x = fsolve(@(x) calibration2_specific(x, tauh, CtoY, n, h, gH, z, hbar),x0); 

        theta_vec(1,i)=x(1);
        H0_vec(1,i)=x(2);
    end;

    z_ideal=mincer*gH/(1-rho);
    parameters(j,10)=z_ideal;
    
    if (z_ideal<=z_upper) && (z_ideal>=z_lower)
        z=z_ideal;
        theta=gH*(tauh*n/(z*CtoY));
        H0=hbar*((1/(gH-(z*h)))-1);
    elseif (z_ideal>=z_upper)
        z=z_upper;
        theta=theta_vec(1,9);
        H0=H0_vec(1,9);
    else 
        z=z_lower;
        theta=theta_vec(1,1);
        H0=H0_vec(1,1);
    end
    
    parameters(j,8)=z;
    parameters(j,4)=theta;
    parameters(j,11)=H0;
    
    %calibration of phi for norms model
    psi=0.1;
    nstar=1;

    if n<3.5
        nprev=3.5;
    else 
       nprev=n;
    end

    phi=(n-nstar)/(nprev-nstar);
    parameters(j,5)=phi;
    
    Hbar=hbar;


    L=1; %land stock
    A=1; %production technology

    n_p=10;

    %Calculate phi in 2010
    n10=params(9,j);
    h10=params(10,j);
    n85=params(5,j);
    h85=params(6,j);
    P=params(12,j);

    if P>0
        phi10=((alpha/n10)-((tau0+tauh*h10)/(1-(tau0+tauh*h10)*n10))-(0.2*(n10-n85)))/(0.2*P*(n85-nstar));
    else
        phi10=phi;
    end
    
    if phi10<0
        phi10=0;
    elseif phi10>1
        phi10=1;
    else
        phi10=phi10;
    end
    
    parameters(j,6)=phi10;
    
    phi_vec_policy=zeros(1,n_p);
    phi_vec_policy(1,1)=phi;
    phi_vec_policy(1,2)=phi-((phi-phi10)/2);
    for i=3:n_p
        phi_vec_policy(1,i)=phi10;
    end


    %1. only norms - with policy change
    phi=(n-nstar)/(nprev-nstar);

    u0=[3, 0.5];
    u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
    nn0 = u(1);
    hdn0 = u(2);

    Ydn0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
    Pdn0=N0+N0*nn0;
    ydn0=Ydn0/Pdn0;
    Xdn0=L/N0;

    hdn = zeros(1,n_p);
    Hdn = zeros(1,n_p);
    nn_vec = zeros(1,n_p);
    Ndn = zeros(1,n_p);
    Pdn = zeros(1,n_p);
    Ydn = zeros(1,n_p);
    ydn = zeros(1,n_p);
    ygrown=zeros(1,n_p-1);
    pgrown=zeros(1,n_p-1);
    Xdn = zeros(1,n_p);
    norm=zeros(1,n_p);

    hdn(1,1)=hdn0;
    Hdn(1,1)=H0;
    nn_vec(1,1)=nn0;
    Ndn(1,1)=N0;
    Ydn(1,1)=Ydn0;
    ydn(1,1)=ydn0;
    Pdn(1,1)=Pdn0;
    Xdn(1,1)=Xdn0;
    norm(1,1)=phi*nprev+(1-phi)*nstar;

    TFR_policy(j,1)=nn0*2;
    TFR_nopolicy(j,1)=nn0*2;
    h_policy(j,1)=hdn0;
    h_nopolicy(j,1)=hdn0;

    for i=2:n_p
       phi=phi_vec_policy(1,i);
       Hdn(1,i)=z*(Hbar+Hdn(1,i-1))*(hdn(1,i-1));
       H_use=Hdn(1,i);
       Ndn(1,i)=Ndn(1,i-1)*nn_vec(1,i-1);
       nprev_use=nn_vec(1,i-1);

       u0=[nn_vec(1,i-1), hdn(1,i-1)];
       options=optimset('MaxFunEvals',100000);
       options=optimset(options,'MaxIter',100000);
       u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0, options);
       nn_vec(1,i) = u(1);
       hdn(1,i) = u(2);
       norm(1,i)= phi*nprev_use+(1-phi)*nstar;

       Ydn(1,i)=A*(((Hbar+Hdn(1,i))*Ndn(1,i))^(1-rho))*((L)^(rho));
       Pdn(1,i)=nn_vec(1,i)*Ndn(1,i)+Ndn(1,i);
       ydn(1,i)=Ydn(1,i)/Pdn(1,i);
       Xdn(1,i)=L/Ndn(1,i);
       ygrown(1,i-1)=(ydn(1,i)-ydn(1,i-1))/ydn(1,i-1);
       pgrown(1,i-1)=(Pdn(1,i)-Pdn(1,i-1))/Pdn(1,i-1);
       
       TFR_policy(j,i)=2*nn_vec(1,i);
       h_policy(j,i)=hdn(1,i);
    end    

    lnydn=log(ydn);
    lnPdn=log(Pdn);
    TFR_norm=2*nn_vec;  

    TFR_data=[n*2;	n85*2; n10*2];
    h_data=[h; h85; h10];
    
    TFR_data_mat(j,1)=n*2;
    TFR_data_mat(j,2)=n85*2;
    TFR_data_mat(j,3)=n10*2;
    
    h_data_mat(j,1)=h;
    h_data_mat(j,2)=h85;
    h_data_mat(j,3)=h10;
end

%Graphs
subplot(5,3,13);
plot(TFR_policy(1,:),'-k','DisplayName','TFR_policy(1,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(1,:),'+','DisplayName','TFR_data_mat(1,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Botswana');
xlabel('t');
ylabel('TFR');

subplot(5,3,1);
plot(TFR_policy(2,:),'-k','DisplayName','TFR_policy(2,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(2,:),'+','DisplayName','TFR_data_mat(2,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('El Salvador');
xlabel('t');
ylabel('TFR');

subplot(5,3,2);
plot(TFR_policy(3,:),'-k','DisplayName','TFR_policy(3,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(3,:),'+','DisplayName','TFR_data_mat(3,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('India');
xlabel('t');
%ylabel('TFR');

subplot(5,3,6);
plot(TFR_policy(4,:),'-k','DisplayName','TFR_policy(4,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(4,:),'+','DisplayName','TFR_data_mat(4,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Indonesia');
xlabel('t');
%ylabel('TFR');

subplot(5,3,7);
plot(TFR_policy(6,:),'-k','DisplayName','TFR_policy(6,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(6,:),'+','DisplayName','TFR_data_mat(6,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Malaysia');
xlabel('t');
ylabel('TFR');

subplot(5,3,8);
plot(TFR_policy(7,:),'-k','DisplayName','TFR_policy(7,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(7,:),'+','DisplayName','TFR_data_mat(7,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Philippines');
xlabel('t');
%ylabel('TFR');

subplot(5,3,11);
plot(TFR_policy(8,:),'-k','DisplayName','TFR_policy(8,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(8,:),'+','DisplayName','TFR_data_mat(8,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Thailand');
xlabel('t');
%ylabel('TFR');

subplot(5,3,4);
plot(TFR_policy(9,:),'-k','DisplayName','TFR_policy(9,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(9,:),'+','DisplayName','TFR_data_mat(9,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Tunisia');
xlabel('t');
ylabel('TFR');

subplot(5,3,3);
plot(TFR_policy(10,:),'-k','DisplayName','TFR_policy(11,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(10,:),'+','DisplayName','TFR_data_mat(11,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Pakistan');
xlabel('t');
%ylabel('TFR');

subplot(5,3,5);
plot(TFR_policy(11,:),'-k','DisplayName','TFR_policy(12,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(11,:),'+','DisplayName','TFR_data_mat(12,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Turkey');
xlabel('t');
%ylabel('TFR');

subplot(5,3,15);
plot(TFR_policy(12,:),'-k','DisplayName','TFR_policy(13,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(12,:),'+','DisplayName','TFR_data_mat(13,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Zimbabwe');
xlabel('t');
%ylabel('TFR');

subplot(5,3,9);
plot(TFR_policy(15,:),'-k','DisplayName','TFR_policy(18,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(15,:),'+','DisplayName','TFR_data_mat(18,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Singapore');
xlabel('t');
%ylabel('TFR');

subplot(5,3,10);
plot(TFR_policy(5,:),'-k','DisplayName','TFR_policy(5,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(5,:),'+','DisplayName','TFR_data_mat(5,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('South Korea');
xlabel('t');
ylabel('TFR');

subplot(5,3,12);
plot(TFR_policy(13,:),'-k','DisplayName','TFR_policy(14,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(13,:),'+','DisplayName','TFR_data_mat(14,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Benin');
xlabel('t');
%ylabel('TFR');


subplot(5,3,14);
plot(TFR_policy(14,:),'-k','DisplayName','TFR_policy(18,:)','LineWidth',2);
hold all;
plot(TFR_data_mat(14,:),'+','DisplayName','TFR_data_mat(18,:)', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Mauritania');
xlabel('t');
%ylabel('TFR');

legend('Prediction - policy', 'Data', 'Orientation','horizontal')

