%values from data (weighted by working age population)
n=2.4;
h=2;
c=2328.126; %to match a C/Y ratio of 80%
y0=2922.658; %GDP pc in 1850
y1=4019.497 ; %1875
N0=9.8;
N1=12.3;

mincer=0.2;
taug=0;

rho=0.33;
tau0=0.021; %the developing country value
hbar=1;
gA=1.56;

u0=[0.02, 2.7, 0.11];
u = fsolve(@(u) calibration_dev(u, tau0, c, n, h, y0, y1, N0, N1, rho, gA),u0); 

tau1=u(1);
gH=u(2);
alpha=u(3);

tauh=tau1+(taug/(n*h));
z_lower=(gH-1)/h;
z_upper=gH/h;

z_vec=linspace(z_lower+0.001, z_upper-0.001, 9);
theta_vec=zeros(1, 9);
H0_vec=zeros(1, 9);


for i=1:9
    z=z_vec(1,i);
    x0=[0.02, 2.7];
    x = fsolve(@(x) calibration2(x, tauh, c, n, h, y0, gH, z, hbar),x0); 

    theta_vec(1,i)=x(1);
    H0_vec(1,i)=x(2);
end;

z_ideal=mincer*gH/(1-rho);
if (z_ideal<=z_upper) && (z_ideal>=z_lower)
    z=z_ideal;
    theta=gH*(tauh*n*y0/(z*c));
    H0=hbar*((1/(gH-(z*h)))-1);
elseif (z_ideal>=z_upper)
    z=z_upper;
    theta=theta_vec(1,9);
    H0=H0_vec(1,9);
else 
    z=z_lower;
    theta=theta_vec(1,1);
    H0=H0_vec(1,1);
end

%calibration of phi for norms model
nstar=1;
nprev=2.45;
Hbar=hbar;


L=1; %land stock
A=1; %production technology
N0=9.8; %initial working age population

n_p=5;


%Norms only with no policy
phi=(n-nstar)/(nprev-nstar);
psi=0.1;

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnp0 = u(1);
hdnp0 = u(2);

Ydnp0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnp0=N0+N0*nnp0;
ydnp0=Ydnp0/Pdnp0;
Xdnp0=L/N0;

hdnp = zeros(1,n_p);
Hdnp = zeros(1,n_p);
nnp_vec = zeros(1,n_p);
Ndnp = zeros(1,n_p);
Pdnp = zeros(1,n_p);
Ydnp = zeros(1,n_p);
ydnp = zeros(1,n_p);
Xdnp = zeros(1,n_p);
ygrownp=zeros(1,n_p-1);
pgrownp=zeros(1,n_p-1);
normnp=zeros(1, n_p);

hdnp(1,1)=hdnp0;
Hdnp(1,1)=H0;
nnp_vec(1,1)=nnp0;
Ndnp(1,1)=N0;
Ydnp(1,1)=Ydnp0;
ydnp(1,1)=ydnp0;
Pdnp(1,1)=Pdnp0;
Xdnp(1,1)=Xdnp0;
normnp(1,1)=phi*nprev+(1-phi)*nstar;


for i=2:n_p
   Hdnp(1,i)=z*(Hbar+Hdnp(1,i-1))*(hdnp(1,i-1));
   H_use=Hdnp(1,i);
   Ndnp(1,i)=Ndnp(1,i-1)*nnp_vec(1,i-1);
   nprev_use=nnp_vec(1,i-1);
   
   options=optimset('MaxFunEvals',100000);
   options=optimset(options,'MaxIter',100000);
   u0=[nnp_vec(1,i-1), hdnp(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0, options);
   nnp_vec(1,i) = u(1);
   hdnp(1,i) = u(2);
   normnp(1,i)=phi*nprev_use+(1-phi)*nstar;
  
   Ydnp(1,i)=A*(((Hbar+Hdnp(1,i))*Ndnp(1,i))^(1-rho))*((L)^(rho));
   Pdnp(1,i)=nnp_vec(1,i)*Ndnp(1,i)+Ndnp(1,i);
   ydnp(1,i)=Ydnp(1,i)/Pdnp(1,i);
   Xdnp(1,i)=L/Ndnp(1,i);
   
   ygrownp(1,i-1)=(ydnp(1,i)-ydnp(1,i-1))/ydnp(1,i-1);
   pgrownp(1,i-1)=(Pdnp(1,i)-Pdnp(1,i-1))/Pdnp(1,i-1);
end    

lnydnp=log(ydnp);
lnPdnp=log(Pdnp);
TFR_norm_np=2*nnp_vec;

