%values from data (weighted by working age population)
n=2.99;
h=5;
c=1258.816; %hh consumption per worker
y0=1508.905; %output per worker
y1=2959.06;
N0=2.02;
N1=3.52;
mincer=0.11;
q=0.774;
taug=0.045;

rho=0.33;
tau1=0.003;
hbar=1;
gA=1.56;

tauh=tau1+(taug/(q*n*h));

u0=[0.02, 2.7, 0.11, 0.04, 0];
u = fsolve(@(u) calibration_mort_new(u, tauh, c, n, h, y0, y1, N0, N1, rho, gA, q),u0); 

tau0=u(1);
gH=u(2);
alpha=u(3);

z_lower=(gH-1)/h;
z_upper=gH/h;

z_ideal=mincer*gH/(1-rho);
if (z_ideal<=z_upper) && (z_ideal>=z_lower)
    z=z_ideal;
elseif (z_ideal>=z_upper)
    z=z_upper;
else 
    z=z_lower;
end

x0=[0.02, 2.7];
x = fsolve(@(x) calibration_mort2(x, tauh, c, n, h, y0, gH, z, hbar, q),x0); 

theta=x(1);
H0=x(2);

%calibration of phi for norms model
psi=0.1;
nstar=1;
nprev=3.5;
qprev=0.7;
phi=(2*(n*q-nstar)+1-q)/(2*(nprev*qprev-nstar));
Hbar=hbar;

L=1; %land stock
A=1; %production technology
N0=2.21; %initial working age population

n_p=10;

phi_vec_policy=zeros(1,n_p);
phi_vec_policy(1,1)=phi;
phi_vec_policy(1,2)=0.7;
for i=3:n_p
    phi_vec_policy(1,i)=0.44;
end

q_vec=zeros(1,n_p);
q_vec(1,1)=0.774;
q_vec(1,2)=0.904;
q_vec(1,3)=0.96;
for i=4:n_p
    q_vec(1,i)=0.96;
end

%1. baseline with mortality
psi=0;
u0=[3, 0.5];
u = fsolve(@(u) myfun_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, qprev, nprev, phi, z, Hbar, H0),u0); 
nm0 = u(1);
nam0 = nm0*q;
hm0 = u(2);

Ym0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pm0=N0+N0*nam0;
ym0=Ym0/Pm0;
Xm0=L/N0;

hm = zeros(1,n_p);
Hm = zeros(1,n_p);
nm_vec = zeros(1,n_p);
nam_vec = zeros(1,n_p);
Nm = zeros(1,n_p);
Pm = zeros(1,n_p);
Ym = zeros(1,n_p);
ym = zeros(1,n_p);
Xm = zeros(1,n_p);
ygrowm=zeros(1,n_p-1);
pgrowm=zeros(1,n_p-1);

hm(1,1)=hm0;
Hm(1,1)=H0;
nm_vec(1,1)=nm0;
nam_vec(1,1)=nam0;
Nm(1,1)=N0;
Ym(1,1)=Ym0;
ym(1,1)=ym0;
Pm(1,1)=Pm0;
Xm(1,1)=Xm0;


for i=2:n_p
   Hm(1,i)=z*(Hbar+Hm(1,i-1))*(hm(1,i-1));
   H_use=Hm(1,i);
   q=q_vec(1,i);
   Nm(1,i)=Nm(1,i-1)*nam_vec(1,i-1);
   nprev_use=nm_vec(1,i-1);
   qprev_use=q_vec(1,i-1);
   
   u0=[nm_vec(1,i-1), hm(1,i-1)];
   u = fsolve(@(u) myfun1_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, nprev_use, qprev_use, phi, z, Hbar, H_use),u0);
   nm_vec(1,i) = u(1);
   nam_vec(1,i) = u(1)*q;
   hm(1,i) = u(2);
  
   Ym(1,i)=A*(((Hbar+Hm(1,i))*Nm(1,i))^(1-rho))*((L)^(rho));
   Pm(1,i)=nam_vec(1,i)*Nm(1,i)+Nm(1,i);
   ym(1,i)=Ym(1,i)/Pm(1,i);
   Xm(1,i)=L/Nm(1,i);
   
   ygrowm(1,i-1)=(ym(1,i)-ym(1,i-1))/ym(1,i-1);
   pgrowm(1,i-1)=(Pm(1,i)-Pm(1,i-1))/Pm(1,i-1);
end    

lnym=log(ym);
lnPm=log(Pm);
TFR_mort=2*nm_vec;
surviving_mort=2*nam_vec;

%2. Norms and mortality
psi=0.1;
q=q_vec(1,1);
u0=[3, 0.5];
u = fsolve(@(u) myfun_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, qprev, nprev, phi, z, Hbar, H0),u0); 
ndp0 = u(1);
nda0 = ndp0*q;
hdn0 = u(2);

Ydn0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdn0=N0+N0*nda0;
ydn0=Ydn0/Pdn0;
Xdn0=L/N0;

hdn = zeros(1,n_p);
Hdn = zeros(1,n_p);
nnp_vec = zeros(1,n_p);
nna_vec = zeros(1,n_p);
Ndn = zeros(1,n_p);
Pdn = zeros(1,n_p);
Ydn = zeros(1,n_p);
ydn = zeros(1,n_p);
ygrown=zeros(1,n_p-1);
pgrown=zeros(1,n_p-1);
Xdn = zeros(1,n_p);

hdn(1,1)=hdn0;
Hdn(1,1)=H0;
nnp_vec(1,1)=ndp0;
nna_vec(1,1)=nda0;
Ndn(1,1)=N0;
Ydn(1,1)=Ydn0;
ydn(1,1)=ydn0;
Pdn(1,1)=Pdn0;
Xdn(1,1)=Xdn0;


for i=2:n_p
   phi=phi_vec_policy(1,i);
   q=q_vec(1,i);
   Hdn(1,i)=z*(Hbar+Hdn(1,i-1))*(hdn(1,i-1));
   H_use=Hdn(1,i);
   Ndn(1,i)=Ndn(1,i-1)*nna_vec(1,i-1);
   nprev_use=nnp_vec(1,i-1);
   qprev_use=q_vec(1,i-1);
   
   u0=[nnp_vec(1,i-1), hdn(1,i-1)];
   u = fsolve(@(u) myfun1_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, nprev_use, qprev_use, phi, z, Hbar, H_use),u0);
   nnp_vec(1,i) = u(1);
   hdn(1,i) = u(2);
   nna_vec(1,i) = nnp_vec(1,i)*q ;
  
   Ydn(1,i)=A*(((Hbar+Hdn(1,i))*Ndn(1,i))^(1-rho))*((L)^(rho));
   Pdn(1,i)=nna_vec(1,i)*Ndn(1,i)+Ndn(1,i);
   ydn(1,i)=Ydn(1,i)/Pdn(1,i);
   Xdn(1,i)=L/Ndn(1,i);
   ygrown(1,i-1)=(ydn(1,i)-ydn(1,i-1))/ydn(1,i-1);
   pgrown(1,i-1)=(Pdn(1,i)-Pdn(1,i-1))/Pdn(1,i-1);
end    

lnydn=log(ydn);
lnPdn=log(Pdn);
TFR_norm=2*nnp_vec;
surviving_norm=2*nna_vec;

%3. Norms and mortality but no policy
psi=0.1;
q=q_vec(1,1);
phi=(2*(n*q-nstar)+1-q)/(2*(nprev*qprev-nstar));

u0=[3, 0.5];
u = fsolve(@(u) myfun_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, qprev, nprev, phi, z, Hbar, H0),u0); 
ndnp0 = u(1);
ndnpa0 = ndnp0*q;
hdnp0 = u(2);

Ydnp0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnp0=N0+N0*ndnpa0;
ydnp0=Ydnp0/Pdnp0;
Xdnp0=L/N0;

hdnp = zeros(1,n_p);
Hdnp = zeros(1,n_p);
ndnp_vec = zeros(1,n_p);
ndnpa_vec = zeros(1,n_p);
Ndnp = zeros(1,n_p);
Pdnp = zeros(1,n_p);
Ydnp = zeros(1,n_p);
ydnp = zeros(1,n_p);
ygrownp=zeros(1,n_p-1);
pgrownp=zeros(1,n_p-1);
Xdnp = zeros(1,n_p);

hdnp(1,1)=hdnp0;
Hdnp(1,1)=H0;
ndnp_vec(1,1)=ndnp0;
ndnpa_vec(1,1)=ndnpa0;
Ndnp(1,1)=N0;
Ydnp(1,1)=Ydnp0;
ydnp(1,1)=ydnp0;
Pdnp(1,1)=Pdnp0;
Xdnp(1,1)=Xdnp0;


for i=2:n_p
   q=q_vec(1,i);
   Hdnp(1,i)=z*(Hbar+Hdnp(1,i-1))*(hdnp(1,i-1));
   H_use=Hdnp(1,i);
   Ndnp(1,i)=Ndnp(1,i-1)*ndnpa_vec(1,i-1);
   nprev_use=ndnp_vec(1,i-1);
   qprev_use=q_vec(1,i-1);
   
   u0=[ndnp_vec(1,i-1), hdnp(1,i-1)];
   u = fsolve(@(u) myfun1_mort141216(u,tau0, tauh, theta, alpha, psi, q, nstar, nprev_use, qprev_use, phi, z, Hbar, H_use),u0);
   ndnp_vec(1,i) = u(1);
   hdnp(1,i) = u(2);
   ndnpa_vec(1,i) = ndnp_vec(1,i)*q ;
  
   Ydnp(1,i)=A*(((Hbar+Hdnp(1,i))*Ndnp(1,i))^(1-rho))*((L)^(rho));
   Pdnp(1,i)=ndnpa_vec(1,i)*Ndnp(1,i)+Ndnp(1,i);
   ydnp(1,i)=Ydnp(1,i)/Pdnp(1,i);
   Xdnp(1,i)=L/Ndnp(1,i);
   ygrownp(1,i-1)=(ydnp(1,i)-ydnp(1,i-1))/ydnp(1,i-1);
   pgrownp(1,i-1)=(Pdnp(1,i)-Pdnp(1,i-1))/Pdnp(1,i-1);
end    

lnydnp=log(ydnp);
lnPdnp=log(Pdnp);
TFR_norm_np=2*ndnp_vec;
surviving_norm_np=2*ndnpa_vec;

%4. Baseline model with no norms or uncertainty

%first, recalibrate
u0=[0.02, 2.7, 0.11, 0.04, 0];
u = fsolve(@(u) calibration(u, tauh, c, n, h, y0, y1, N0, N1, rho, gA),u0); 

tau0=u(1);
gH=u(2);
alpha=u(3);

z_lower=(gH-1)/h;
z_upper=gH/h;

z_ideal=mincer*gH/(1-rho);
if (z_ideal<=z_upper) && (z_ideal>=z_lower)
    z=z_ideal;
    theta=gH*(tauh*n*y0/(z*c));
    H0=hbar*((1/(gH-(z*h)))-1);
elseif (z_ideal>=z_upper)
    z=z_upper;
    theta=theta_vec(1,9);
    H0=H0_vec(1,9);
else 
    z=z_lower;
    theta=theta_vec(1,1);
    H0=H0_vec(1,1);
end

u0=0.5;
ht = fsolve(@(ht) myfun_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H0),u0); 
hb0 = ht;
nb0=alpha/((1+alpha)*(tau0+tauh*hb0));

Yb0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pb0=N0+N0*nb0;
yb0=Yb0/Pb0;
Xb0=L/N0;

%dynamic path

hb = zeros(1,n_p);
Hb = zeros(1,n_p);
nb_vec = zeros(1,n_p);
Nb = zeros(1,n_p);
Pb = zeros(1,n_p);
Yb = zeros(1,n_p);
yb = zeros(1,n_p);
Xb = zeros(1,n_p);
ygrowb=zeros(1,n_p-1);
pgrowb=zeros(1,n_p-1);

hb(1,1)=hb0;
Hb(1,1)=H0;
nb_vec(1,1)=nb0;
Nb(1,1)=N0;
Yb(1,1)=Yb0;
yb(1,1)=yb0;
Pb(1,1)=Pb0;
Xb(1,1)=Xb0;


for i=2:n_p
   Hb(1,i)=z*(Hbar+Hb(1,i-1))*(hb(1,i-1));
   H_use=Hb(1,i);
   Nb(1,i)=Nb(1,i-1)*nb_vec(1,i-1);
      
   u0=[hb(1,i-1)];
   ht = fsolve(@(ht) myfun1_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H_use),u0);
   hb(1,i)=ht;
   nb_vec(1,i) = alpha/((1+alpha)*(tau0+tauh*hb(1,i)));
   
   Yb(1,i)=A*(((Hbar+Hb(1,i))*Nb(1,i))^(1-rho))*((L)^(rho));
   Pb(1,i)=nb_vec(1,i)*Nb(1,i)+Nb(1,i);
   yb(1,i)=Yb(1,i)/Pb(1,i);
   Xb(1,i)=L/Nb(1,i);
   
   ygrowb(1,i-1)=(yb(1,i)-yb(1,i-1))/yb(1,i-1);
   pgrowb(1,i-1)=(Pb(1,i)-Pb(1,i-1))/Pb(1,i-1);
end    

lnyb=log(yb);
lnPb=log(Pb);
TFR_base=2*nb_vec;

TFR_data=[5.97;	3.94; 2.51];
h_data=[5; 7.846254; 10.67555];
surviving_data=[4.773; 3.505; 2.382];
popgrowth_data=[0.56;0.32];
ygrowth_data=[1;1.5];

subplot(1,2,1);
plot(TFR_norm,'-g','DisplayName','TFR_norm','LineWidth',2);
hold all;
% plot(TFR_norm_np,':r','DisplayName','TFR_norml','LineWidth',2);
% hold all;
plot(TFR_mort,'--m','DisplayName','TFR_norm_np','LineWidth',2);
hold all;
plot(TFR_base,'-.b','DisplayName','TFR_base','LineWidth',2);
hold all;
plot(TFR_data,'+','DisplayName','TFR_data', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;

title('Fertility', 'fontsize',14);
xlabel('t', 'fontsize',14);

subplot(1,2,2);
plot(hdn,'-g','DisplayName','hdn','LineWidth',2);
hold all;
% plot(hdnp,':r','DisplayName','TFR_norml','LineWidth',2);
% hold all;
plot(hm,'--m','DisplayName','hdnp','LineWidth',2);
hold all;
plot(hb,'-.b','DisplayName','hb','LineWidth',2);
hold all;
plot(h_data,'+','DisplayName','hb', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Human capital investment', 'fontsize',14);
xlabel('t', 'fontsize',14);

ax1 = subplot(1,2,1);
ylabel(ax1,'TFR', 'fontsize',14);
ax2 = subplot(1,2,2);
ylabel(ax2,'Years of schooling', 'fontsize',14);
% ax3 = subplot(1,3,3);
% ylabel(ax3,'y');
% ax4 = subplot(2,2,4);
% ylabel(ax4,'P');


leg1=legend('Baseline+mortality+norms', 'Baseline+mortality', 'Baseline','Orientation','horizontal');
set(leg1, 'fontsize',12)


plot(surviving_norm,'-g','DisplayName','surviving_norm','LineWidth',2);
hold all;
% plot(surviving_norm_np,'.-r','DisplayName','surviving_norm_np','LineWidth',2);
% hold all;
plot(surviving_mort,'--m','DisplayName','surviving_mort', 'LineWidth',2);
hold all;
plot(TFR_base,'-.b','DisplayName','TFR_norm','LineWidth',2);
hold all;
plot(surviving_data,'+','DisplayName','surviving_data', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Number of surviving children', 'fontsize',14);
xlabel('t', 'fontsize',14);
% 
leg=legend('Baseline+mortality+norms', 'Baseline+mortality', 'Baseline','Orientation','horizontal');
set(leg, 'fontsize', 12)
