%values from data
n=2.99;
h=5;
c=1258.816; %hh consumption per worker
y0=1508.905; %output per worker
y1=2959.06;
N0=2.02;
N1=3.52;
mincer=0.11;
taug=0.045;

rho=0.33;
tau1=0.003;
hbar=1;
gA=1.56;

tauh=tau1+(taug/(n*h));

u0=[0.02, 2.7, 0.11];
u = fsolve(@(u) calibration(u, tauh, c, n, h, y0, y1, N0, N1, rho, gA),u0); 

tau0=u(1);
gH=u(2);
alpha=u(3);

z_lower=(gH-1)/h;
z_upper=gH/h;

z_vec=linspace(z_lower+0.001, z_upper-0.001, 9);
theta_vec=zeros(1, 9);
H0_vec=zeros(1, 9);

for i=1:9
    z=z_vec(1,i);
    x0=[0.02, 2.7];
    x = fsolve(@(x) calibration2(x, tauh, c, n, h, y0, gH, z, hbar),x0); 

    theta_vec(1,i)=x(1);
    H0_vec(1,i)=x(2);
end;

z_ideal=mincer*gH/(1-rho);
if (z_ideal<=z_upper) && (z_ideal>=z_lower)
    z=z_ideal;
    theta=gH*(tauh*n*y0/(z*c));
    H0=hbar*((1/(gH-(z*h)))-1);
elseif (z_ideal>=z_upper)
    z=z_upper;
    theta=theta_vec(1,9);
    H0=H0_vec(1,9);
else 
    z=z_lower;
    theta=theta_vec(1,1);
    H0=H0_vec(1,1);
end

%calibration of phi for norms model
psi=0.1;
nstar=1;
nprev=3.5;
phi=(n-nstar)/(nprev-nstar); %here the weight on previous fertility
Hbar=hbar;


L=1; %land stock
A=1; %production technology
N0=2.21; %initial working age population

n_p=10;

phi_vec_policy1=zeros(1,n_p);
phi_vec_policy1(1,1)=phi;
phi_vec_policy1(1,2)=0.6;
for i=3:n_p
    phi_vec_policy1(1,i)=0.37;
end


%1. psi=0.1
%a. changing phi
psi=0.1;
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nn0 = u(1);
hdn0 = u(2);

Ydn0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdn0=N0+N0*nn0;
ydn0=Ydn0/Pdn0;
Xdn0=L/N0;

hdn = zeros(1,n_p);
Hdn = zeros(1,n_p);
nn_vec = zeros(1,n_p);
Ndn = zeros(1,n_p);
Pdn = zeros(1,n_p);
Ydn = zeros(1,n_p);
ydn = zeros(1,n_p);
ygrown=zeros(1,n_p-1);
pgrown=zeros(1,n_p-1);
Xdn = zeros(1,n_p);

hdn(1,1)=hdn0;
Hdn(1,1)=H0;
nn_vec(1,1)=nn0;
Ndn(1,1)=N0;
Ydn(1,1)=Ydn0;
ydn(1,1)=ydn0;
Pdn(1,1)=Pdn0;
Xdn(1,1)=Xdn0;


for i=2:n_p
   phi=phi_vec_policy1(1,i);
   Hdn(1,i)=z*(Hbar+Hdn(1,i-1))*(hdn(1,i-1));
   H_use=Hdn(1,i);
   Ndn(1,i)=Ndn(1,i-1)*nn_vec(1,i-1);
   nprev_use=nn_vec(1,i-1);
   
   u0=[nn_vec(1,i-1), hdn(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nn_vec(1,i) = u(1);
   hdn(1,i) = u(2);
  
   Ydn(1,i)=A*(((Hbar+Hdn(1,i))*Ndn(1,i))^(1-rho))*((L)^(rho));
   Pdn(1,i)=nn_vec(1,i)*Ndn(1,i)+Ndn(1,i);
   ydn(1,i)=Ydn(1,i)/Pdn(1,i);
   Xdn(1,i)=L/Ndn(1,i);
   ygrown(1,i-1)=(ydn(1,i)-ydn(1,i-1))/ydn(1,i-1);
   pgrown(1,i-1)=(Pdn(1,i)-Pdn(1,i-1))/Pdn(1,i-1);
end    

lnydn=log(ydn);
lnPdn=log(Pdn);
TFR_norm=2*nn_vec;

%b. unchanging phi
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnp0 = u(1);
hdnp0 = u(2);

Ydnp0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnp0=N0+N0*nnp0;
ydnp0=Ydnp0/Pdnp0;
Xdnp0=L/N0;

hdnp = zeros(1,n_p);
Hdnp = zeros(1,n_p);
nnp_vec = zeros(1,n_p);
Ndnp = zeros(1,n_p);
Pdnp = zeros(1,n_p);
Ydnp = zeros(1,n_p);
ydnp = zeros(1,n_p);
Xdnp = zeros(1,n_p);
ygrownp=zeros(1,n_p-1);
pgrownp=zeros(1,n_p-1);

hdnp(1,1)=hdnp0;
Hdnp(1,1)=H0;
nnp_vec(1,1)=nnp0;
Ndnp(1,1)=N0;
Ydnp(1,1)=Ydnp0;
ydnp(1,1)=ydnp0;
Pdnp(1,1)=Pdnp0;
Xdnp(1,1)=Xdnp0;


for i=2:n_p
   Hdnp(1,i)=z*(Hbar+Hdnp(1,i-1))*(hdnp(1,i-1));
   H_use=Hdnp(1,i);
   Ndnp(1,i)=Ndnp(1,i-1)*nnp_vec(1,i-1);
   nprev_use=nnp_vec(1,i-1);
   
   u0=[nnp_vec(1,i-1), hdnp(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnp_vec(1,i) = u(1);
   hdnp(1,i) = u(2);
  
   Ydnp(1,i)=A*(((Hbar+Hdnp(1,i))*Ndnp(1,i))^(1-rho))*((L)^(rho));
   Pdnp(1,i)=nnp_vec(1,i)*Ndnp(1,i)+Ndnp(1,i);
   ydnp(1,i)=Ydnp(1,i)/Pdnp(1,i);
   Xdnp(1,i)=L/Ndnp(1,i);
   
   ygrownp(1,i-1)=(ydnp(1,i)-ydnp(1,i-1))/ydnp(1,i-1);
   pgrownp(1,i-1)=(Pdnp(1,i)-Pdnp(1,i-1))/Pdnp(1,i-1);
end    

lnydnp=log(ydnp);
lnPdnp=log(Pdnp);
TFR_norm_np=2*nnp_vec;


%2. psi=0.05 - small
%a. Changing phi
phi_vec_policy2=zeros(1,n_p);
phi_vec_policy2(1,1)=phi;
phi_vec_policy2(1,2)=0.55;
for i=3:n_p
    phi_vec_policy2(1,i)=0.33;
end

psi=0.05;
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nntnp0 = u(1);
hdntnp0 = u(2);

Ydnt0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnt0=N0+N0*nntnp0;
ydnt0=Ydnt0/Pdnt0;
Xdnt0=L/N0;

hdnt = zeros(1,n_p);
Hdnt = zeros(1,n_p);
nnt_vec = zeros(1,n_p);
Ndnt = zeros(1,n_p);
Pdnt = zeros(1,n_p);
Ydnt = zeros(1,n_p);
ydnt = zeros(1,n_p);
ygrownt=zeros(1,n_p-1);
pgrownt=zeros(1,n_p-1);
Xdnt = zeros(1,n_p);

hdnt(1,1)=hdntnp0;
Hdnt(1,1)=H0;
nnt_vec(1,1)=nntnp0;
Ndnt(1,1)=N0;
Ydnt(1,1)=Ydnt0;
ydnt(1,1)=ydnt0;
Pdnt(1,1)=Pdnt0;
Xdnt(1,1)=Xdnt0;


for i=2:n_p
   phi=phi_vec_policy2(1,i);
   Hdnt(1,i)=z*(Hbar+Hdnt(1,i-1))*(hdnt(1,i-1));
   H_use=Hdnt(1,i);
   Ndnt(1,i)=Ndnt(1,i-1)*nnt_vec(1,i-1);
   nprev_use=nnt_vec(1,i-1);
   
   u0=[nnt_vec(1,i-1), hdnt(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnt_vec(1,i) = u(1);
   hdnt(1,i) = u(2);
  
   Ydnt(1,i)=A*(((Hbar+Hdnt(1,i))*Ndnt(1,i))^(1-rho))*((L)^(rho));
   Pdnt(1,i)=nnt_vec(1,i)*Ndnt(1,i)+Ndnt(1,i);
   ydnt(1,i)=Ydnt(1,i)/Pdnt(1,i);
   Xdnt(1,i)=L/Ndnt(1,i);
   ygrownt(1,i-1)=(ydnt(1,i)-ydnt(1,i-1))/ydnt(1,i-1);
   pgrownt(1,i-1)=(Pdnt(1,i)-Pdnt(1,i-1))/Pdnt(1,i-1);
end    

lnydnt=log(ydnt);
lnPdnt=log(Pdnt);
TFR_normt=2*nnt_vec;

%b. unchanging phi
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnpt0 = u(1);
hdnpt0 = u(2);

Ydnpt0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnpt0=N0+N0*nnpt0;
ydnpt0=Ydnpt0/Pdnpt0;
Xdnpt0=L/N0;

hdnpt = zeros(1,n_p);
Hdnpt = zeros(1,n_p);
nnpt_vec = zeros(1,n_p);
Ndnpt = zeros(1,n_p);
Pdnpt = zeros(1,n_p);
Ydnpt = zeros(1,n_p);
ydnpt = zeros(1,n_p);
Xdnpt = zeros(1,n_p);
ygrownpt=zeros(1,n_p-1);
pgrownpt=zeros(1,n_p-1);

hdnpt(1,1)=hdnpt0;
Hdnpt(1,1)=H0;
nnpt_vec(1,1)=nnpt0;
Ndnpt(1,1)=N0;
Ydnpt(1,1)=Ydnpt0;
ydnpt(1,1)=ydnpt0;
Pdnpt(1,1)=Pdnpt0;
Xdnpt(1,1)=Xdnpt0;


for i=2:n_p
   Hdnpt(1,i)=z*(Hbar+Hdnpt(1,i-1))*(hdnpt(1,i-1));
   H_use=Hdnpt(1,i);
   Ndnpt(1,i)=Ndnpt(1,i-1)*nnpt_vec(1,i-1);
   nprev_use=nnpt_vec(1,i-1);
   
   u0=[nnpt_vec(1,i-1), hdnpt(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnpt_vec(1,i) = u(1);
   hdnpt(1,i) = u(2);
  
   Ydnpt(1,i)=A*(((Hbar+Hdnpt(1,i))*Ndnpt(1,i))^(1-rho))*((L)^(rho));
   Pdnpt(1,i)=nnpt_vec(1,i)*Ndnpt(1,i)+Ndnpt(1,i);
   ydnpt(1,i)=Ydnpt(1,i)/Pdnpt(1,i);
   Xdnpt(1,i)=L/Ndnpt(1,i);
   
   ygrownpt(1,i-1)=(ydnpt(1,i)-ydnpt(1,i-1))/ydnpt(1,i-1);
   pgrownpt(1,i-1)=(Pdnpt(1,i)-Pdnpt(1,i-1))/Pdnpt(1,i-1);
end    

lnydnpt=log(ydnpt);
lnPdnpt=log(Pdnpt);
TFR_norm_npt=2*nnpt_vec;

%3. psi=0.5 - big
%a. Changing phi
phi_vec_policy3=zeros(1,n_p);
phi_vec_policy3(1,1)=phi;
phi_vec_policy3(1,2)=0.6;
for i=3:n_p
    phi_vec_policy3(1,i)=0.4;
end

psi=0.5;
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnb0 = u(1);
hdnb0 = u(2);

Ydnb0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnb0=N0+N0*nnb0;
ydnb0=Ydnb0/Pdnb0;
Xdnb0=L/N0;

%changing phi
hdnb = zeros(1,n_p);
Hdnb = zeros(1,n_p);
nnb_vec = zeros(1,n_p);
Ndnb = zeros(1,n_p);
Pdnb = zeros(1,n_p);
Ydnb = zeros(1,n_p);
ydnb = zeros(1,n_p);
ygrownb=zeros(1,n_p-1);
pgrownb=zeros(1,n_p-1);
Xdnb = zeros(1,n_p);

hdnb(1,1)=hdnb0;
Hdnb(1,1)=H0;
nnb_vec(1,1)=nnb0;
Ndnb(1,1)=N0;
Ydnb(1,1)=Ydnb0;
ydnb(1,1)=ydnb0;
Pdnb(1,1)=Pdnb0;
Xdnb(1,1)=Xdnb0;


for i=2:n_p
   phi=phi_vec_policy3(1,i);
   Hdnb(1,i)=z*(Hbar+Hdnb(1,i-1))*(hdnb(1,i-1));
   H_use=Hdnb(1,i);
   Ndnb(1,i)=Ndnb(1,i-1)*nnb_vec(1,i-1);
   nprev_use=nnb_vec(1,i-1);
   
   u0=[nnb_vec(1,i-1), hdnb(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnb_vec(1,i) = u(1);
   hdnb(1,i) = u(2);
  
   Ydnb(1,i)=A*(((Hbar+Hdnb(1,i))*Ndnb(1,i))^(1-rho))*((L)^(rho));
   Pdnb(1,i)=nnb_vec(1,i)*Ndnb(1,i)+Ndnb(1,i);
   ydnb(1,i)=Ydnb(1,i)/Pdnb(1,i);
   Xdnb(1,i)=L/Ndnb(1,i);
   ygrownb(1,i-1)=(ydnb(1,i)-ydnb(1,i-1))/ydnb(1,i-1);
   pgrownb(1,i-1)=(Pdnb(1,i)-Pdnb(1,i-1))/Pdnb(1,i-1);
end    

lnydnb=log(ydnb);
lnPdnb=log(Pdnb);
TFR_normb=2*nnb_vec;

%b. unchanging phi
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnpb0 = u(1);
hdnpb0 = u(2);

Ydnpb0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnpb0=N0+N0*nnpb0;
ydnpb0=Ydnpb0/Pdnpb0;
Xdnpb0=L/N0;

hdnpb = zeros(1,n_p);
Hdnpb = zeros(1,n_p);
nnpb_vec = zeros(1,n_p);
Ndnpb = zeros(1,n_p);
Pdnpb = zeros(1,n_p);
Ydnpb = zeros(1,n_p);
ydnpb = zeros(1,n_p);
Xdnpb = zeros(1,n_p);
ygrownpb=zeros(1,n_p-1);
pgrownpb=zeros(1,n_p-1);

hdnpb(1,1)=hdnpb0;
Hdnpb(1,1)=H0;
nnpb_vec(1,1)=nnpb0;
Ndnpb(1,1)=N0;
Ydnpb(1,1)=Ydnpb0;
ydnpb(1,1)=ydnpb0;
Pdnpb(1,1)=Pdnpb0;
Xdnpb(1,1)=Xdnpb0;


for i=2:n_p
   Hdnpb(1,i)=z*(Hbar+Hdnpb(1,i-1))*(hdnpb(1,i-1));
   H_use=Hdnpb(1,i);
   Ndnpb(1,i)=Ndnpb(1,i-1)*nnpb_vec(1,i-1);
   nprev_use=nnpb_vec(1,i-1);
   
   u0=[nnpb_vec(1,i-1), hdnpb(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnpb_vec(1,i) = u(1);
   hdnpb(1,i) = u(2);
  
   Ydnpb(1,i)=A*(((Hbar+Hdnpb(1,i))*Ndnpb(1,i))^(1-rho))*((L)^(rho));
   Pdnpb(1,i)=nnpb_vec(1,i)*Ndnpb(1,i)+Ndnpb(1,i);
   ydnpb(1,i)=Ydnpb(1,i)/Pdnpb(1,i);
   Xdnpb(1,i)=L/Ndnpb(1,i);
   
   ygrownpb(1,i-1)=(ydnpb(1,i)-ydnpb(1,i-1))/ydnpb(1,i-1);
   pgrownpb(1,i-1)=(Pdnpb(1,i)-Pdnpb(1,i-1))/Pdnpb(1,i-1);
end    

lnydnpb=log(ydnpb);
lnPdnpb=log(Pdnpb);
TFR_norm_npb=2*nnpb_vec;

%4. psi=0.9 - huge
%a. Changing phi
psi=0.9;
phi=(n-nstar)/(nprev-nstar);

phi_vec_policy4=zeros(1,n_p);
phi_vec_policy4(1,1)=phi;
phi_vec_policy4(1,2)=0.6;
for i=3:n_p
    phi_vec_policy4(1,i)=0.41;
end

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnh0 = u(1);
hdnh0 = u(2);

Ydnh0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnh0=N0+N0*nnh0;
ydnh0=Ydnh0/Pdnh0;
Xdnh0=L/N0;

hdnh = zeros(1,n_p);
Hdnh = zeros(1,n_p);
nnh_vec = zeros(1,n_p);
Ndnh = zeros(1,n_p);
Pdnh = zeros(1,n_p);
Ydnh = zeros(1,n_p);
ydnh = zeros(1,n_p);
ygrownh=zeros(1,n_p-1);
pgrownh=zeros(1,n_p-1);
Xdnh = zeros(1,n_p);

hdnh(1,1)=hdnh0;
Hdnh(1,1)=H0;
nnh_vec(1,1)=nnh0;
Ndnh(1,1)=N0;
Ydnh(1,1)=Ydnh0;
ydnh(1,1)=ydnh0;
Pdnh(1,1)=Pdnh0;
Xdnh(1,1)=Xdnh0;


for i=2:n_p
   phi=phi_vec_policy4(1,i);
   Hdnh(1,i)=z*(Hbar+Hdnh(1,i-1))*(hdnh(1,i-1));
   H_use=Hdnh(1,i);
   Ndnh(1,i)=Ndnh(1,i-1)*nnh_vec(1,i-1);
   nprev_use=nnh_vec(1,i-1);
   
   u0=[nnh_vec(1,i-1), hdnh(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnh_vec(1,i) = u(1);
   hdnh(1,i) = u(2);
  
   Ydnh(1,i)=A*(((Hbar+Hdnh(1,i))*Ndnh(1,i))^(1-rho))*((L)^(rho));
   Pdnh(1,i)=nnh_vec(1,i)*Ndnh(1,i)+Ndnh(1,i);
   ydnh(1,i)=Ydnh(1,i)/Pdnh(1,i);
   Xdnh(1,i)=L/Ndnh(1,i);
   ygrownh(1,i-1)=(ydnh(1,i)-ydnh(1,i-1))/ydnh(1,i-1);
   pgrownh(1,i-1)=(Pdnh(1,i)-Pdnh(1,i-1))/Pdnh(1,i-1);
end    

lnydnh=log(ydnh);
lnPdnh=log(Pdnh);
TFR_normh=2*nnh_vec;

%b. unchanging phi
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnph0 = u(1);
hdnph0 = u(2);

Ydnph0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnph0=N0+N0*nnph0;
ydnph0=Ydnph0/Pdnph0;
Xdnph0=L/N0;

hdnph = zeros(1,n_p);
Hdnph = zeros(1,n_p);
nnph_vec = zeros(1,n_p);
Ndnph = zeros(1,n_p);
Pdnph = zeros(1,n_p);
Ydnph = zeros(1,n_p);
ydnph = zeros(1,n_p);
Xdnph = zeros(1,n_p);
ygrownph=zeros(1,n_p-1);
pgrownph=zeros(1,n_p-1);

hdnph(1,1)=hdnph0;
Hdnph(1,1)=H0;
nnph_vec(1,1)=nnph0;
Ndnph(1,1)=N0;
Ydnph(1,1)=Ydnph0;
ydnph(1,1)=ydnph0;
Pdnph(1,1)=Pdnph0;
Xdnph(1,1)=Xdnph0;


for i=2:n_p
   Hdnph(1,i)=z*(Hbar+Hdnph(1,i-1))*(hdnph(1,i-1));
   H_use=Hdnph(1,i);
   Ndnph(1,i)=Ndnph(1,i-1)*nnph_vec(1,i-1);
   nprev_use=nnph_vec(1,i-1);
   
   u0=[nnph_vec(1,i-1), hdnph(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0);
   nnph_vec(1,i) = u(1);
   hdnph(1,i) = u(2);
  
   Ydnph(1,i)=A*(((Hbar+Hdnph(1,i))*Ndnph(1,i))^(1-rho))*((L)^(rho));
   Pdnph(1,i)=nnph_vec(1,i)*Ndnph(1,i)+Ndnph(1,i);
   ydnph(1,i)=Ydnph(1,i)/Pdnph(1,i);
   Xdnph(1,i)=L/Ndnph(1,i);
   
   ygrownph(1,i-1)=(ydnph(1,i)-ydnph(1,i-1))/ydnph(1,i-1);
   pgrownph(1,i-1)=(Pdnph(1,i)-Pdnph(1,i-1))/Pdnph(1,i-1);
end    

lnydnph=log(ydnph);
lnPdnph=log(Pdnph);
TFR_norm_nph=2*nnph_vec;

%5. psi=0
u0=0.5;
ht = fsolve(@(ht) myfun_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H0),u0); 
hb0 = ht;
nb0=alpha/((1+alpha)*(tau0+tauh*hb0));

Yb0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pb0=N0+N0*nb0;
yb0=Yb0/Pb0;
Xb0=L/N0;

%dynamic path

hb = zeros(1,n_p);
Hb = zeros(1,n_p);
nb_vec = zeros(1,n_p);
Nb = zeros(1,n_p);
Pb = zeros(1,n_p);
Yb = zeros(1,n_p);
yb = zeros(1,n_p);
Xb = zeros(1,n_p);
ygrowb=zeros(1,n_p-1);
pgrowb=zeros(1,n_p-1);

hb(1,1)=hb0;
Hb(1,1)=H0;
nb_vec(1,1)=nb0;
Nb(1,1)=N0;
Yb(1,1)=Yb0;
yb(1,1)=yb0;
Pb(1,1)=Pb0;
Xb(1,1)=Xb0;


for i=2:n_p
   Hb(1,i)=z*(Hbar+Hb(1,i-1))*(hb(1,i-1));
   H_use=Hb(1,i);
   Nb(1,i)=Nb(1,i-1)*nb_vec(1,i-1);
      
   u0=[hb(1,i-1)];
   ht = fsolve(@(ht) myfun1_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H_use),u0);
   hb(1,i)=ht;
   nb_vec(1,i) = alpha/((1+alpha)*(tau0+tauh*hb(1,i)));
   
   Yb(1,i)=A*(((Hbar+Hb(1,i))*Nb(1,i))^(1-rho))*((L)^(rho));
   Pb(1,i)=nb_vec(1,i)*Nb(1,i)+Nb(1,i);
   yb(1,i)=Yb(1,i)/Pb(1,i);
   Xb(1,i)=L/Nb(1,i);
   
   ygrowb(1,i-1)=(yb(1,i)-yb(1,i-1))/yb(1,i-1);
   pgrowb(1,i-1)=(Pb(1,i)-Pb(1,i-1))/Pb(1,i-1);
end    

lnyb=log(yb);
lnPb=log(Pb);
TFR_base=2*nb_vec;

TFR_data=[5.97;	3.94; 2.51];
h_data=[5; 7.846254; 10.67555];

subplot(1,2,1);
plot(TFR_norm,'-g','DisplayName','TFR_norm','LineWidth',2);
hold all;
plot(TFR_normt,'--r','DisplayName','TFR_normt','LineWidth',2);
hold all;
plot(TFR_normb,'-.m','DisplayName','TFR_norm_npb','LineWidth',2);
hold all;
% plot(TFR_base,':b','DisplayName','TFR_base','LineWidth',2);
% hold all;
plot(TFR_data,'+','DisplayName','TFR_data', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;

title('Fertility', 'fontsize',14);
xlabel('t', 'fontsize',14);

subplot(1,2,2);
plot(hdn,'-g','DisplayName','hdn','LineWidth',2);
hold all;
plot(hdnt,'--r','DisplayName','hdnt','LineWidth',2);
hold all;
plot(hdnb,'-.m','DisplayName','hdnpb','LineWidth',2);
hold all;
% plot(hb,':b','DisplayName','hbb','LineWidth',2);
% hold all;
plot(h_data,'+','DisplayName','hb', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Human capital investment', 'fontsize',14);
xlabel('t', 'fontsize',14);

ax1 = subplot(1,2,1);
ylabel(ax1,'TFR', 'fontsize',14);
ax2 = subplot(1,2,2);
ylabel(ax2,'Years of schooling', 'fontsize',14);
% ax3 = subplot(2,2,3);
% ylabel(ax3,'y');
% ax4 = subplot(2,2,4);
% ylabel(ax4,'P');


leg=legend('psi=0.1', 'psi=0.05', 'psi=0.5','Orientation','horizontal');
set(leg, 'fontsize',12);
